// SNF4CGP/InputProcessor.hpp
// Copyright (C) 2009 ARM Research Labs, LLC
// See www.armresearch.com for more information.
//
// The InputProcessor is responsible for accpting and parsing commands from
// CommuniGate.

#ifndef IncludedInputProcessor
#define IncludedInputProcessor

#include <string>

using namespace std;

struct Command {                                                                // Parsed Command Objects
    unsigned int Number;                                                        // Commands have a serial number
    enum CommandType {                                                          // Commands have these types:
        UNKNOWN;                                                                // We don't know this command.
        QUIT;                                                                   // It is time to stop the app.
        WAKE;                                                                   // Report the app is now awake.
        INTF;                                                                   // Report the interface version.
        FILE;                                                                   // Scan this file.
    } Type;                                                                     // Here is where we keep it.
    string Data;                                                                // Other command data goes here.
};

class InputProcessor {                                                          // Here is the InputProcessor object.

  public:
    Command getCommand();                                                       // One method: get the next command.

};

#endif
